searchNodes=[{"ref":"Dilute.html","title":"Dilute","type":"module","doc":"Ecto.Schema are very similar to Absinthe.Type.Object definitions and are required to be kept in sync. Dilute is able to derive Absinthe objects and their relations based on Ecto.Schema definitions and offers the ability to translate query resolutions into efficient SQL statements. Types Absinthe objects placed inside your Types module: defmodule MyAppWeb.Schema.Types do use Absinthe.Schema.Notation import Dilute alias MyApp.Blog.{Post, Comment} dilute_object(Post) dilute_object(Comment) end Resolution The resolver can be defined with: defmodule MyAppWeb.Resolver do use Dilute.Resolver, types: MyAppWeb.Schema.Types, repo: MyApp.Repo end Queries can either be defined using the resolve/3 function ... defmodule MyAppWeb.Schema do use Absinthe.Schema alias MyAppWeb.{Resolver, Schema} import_types(Schema.Types) query do @desc &quot;Get one Post&quot; field :post, :post do resolve(&amp;Resolver.resolve/3) end end end ... or the query_fields/2 macro. defmodule MyAppWeb.Schema do use Absinthe.Schema alias MyAppWeb.{Resolver, Schema} import_types(Schema.Types) query do MyWebApp.Schema.query_fields(:post, &amp;Resolver.resolve/3) end end"},{"ref":"Dilute.html#dilute_input_object/1","title":"Dilute.dilute_input_object/1","type":"macro","doc":""},{"ref":"Dilute.html#dilute_input_object/2","title":"Dilute.dilute_input_object/2","type":"macro","doc":""},{"ref":"Dilute.html#dilute_input_object/3","title":"Dilute.dilute_input_object/3","type":"macro","doc":""},{"ref":"Dilute.html#dilute_object/1","title":"Dilute.dilute_object/1","type":"macro","doc":"Defines an Absinthe object based on the ecto schema of the given module. Settings the :associations option to false will omit the associations in the definition. Fields can be excluded using the :exclude option. dilute_object Post, exclude: :id do end Additionally the do block will override any field definitions. dilute_object Post do field(:rating, :float) end Ecto allows for Custom Type definitions which have to be overwritten."},{"ref":"Dilute.html#dilute_object/2","title":"Dilute.dilute_object/2","type":"macro","doc":""},{"ref":"Dilute.html#dilute_object/3","title":"Dilute.dilute_object/3","type":"macro","doc":""},{"ref":"Dilute.html#resolve_modules/2","title":"Dilute.resolve_modules/2","type":"function","doc":""},{"ref":"Dilute.html#schema_identifier/2","title":"Dilute.schema_identifier/2","type":"function","doc":""},{"ref":"Dilute.Adapter.html","title":"Dilute.Adapter","type":"behaviour","doc":"Adapters serve as a translator between schema libaries and Dilute. One of the build in Adapters is the Ecto adapter, which can be used to derive absinthe object definitions from Ecto schemas. The callbacks that have to be implemented are: applicable?/1 - Checks if the given module is a valid subject for the adapter and returns true/false iex&gt; Dilute.Adapter.Ecto.applicable?(Comment) true iex&gt; Dilute.Adapter.Ecto.applicable?(NoEctoSchema) false fields/1 - Returns a list of fields wich can be processed by Dilute afterwards. Each field is represented as a tuple {field, cardinality, type, related}. field is the atom identifier of the field cardinality either :one or :many type a valid absinthe type. If the field references another object type has to be :&quot;$module&quot; related either the source type (for an ecto :utc_datetime which is mapped to :datetime this would be :utc_datetime), or should it be an reference to another module this has to be the respective module. iex&gt; Dilute.Adapter.Ecto.fields(Comment) [ {:id, :one, :id, :id}, {:content, :one, :string, :string}, {:votes, :one, :integer, :integer}, {:last_viewed, :one, :integer, DiluteTest.Environment.Ecto.UnixTime}, {:post_id, :one, :id, :id}, {:inserted_at, :one, :naive_datetime, :naive_datetime}, {:updated_at, :one, :naive_datetime, :naive_datetime}, ]"},{"ref":"Dilute.Adapter.html#c:applicable?/1","title":"Dilute.Adapter.applicable?/1","type":"callback","doc":""},{"ref":"Dilute.Adapter.html#c:fields/1","title":"Dilute.Adapter.fields/1","type":"callback","doc":""},{"ref":"Dilute.AdapterError.html","title":"Dilute.AdapterError","type":"exception","doc":"Raised during compiletime should an adapter run into unresolvable errors"},{"ref":"Dilute.Resolution.html","title":"Dilute.Resolution","type":"module","doc":"Query-esque representation for Absinthe.Resolutions."},{"ref":"Dilute.Resolution.html#derive_resolution/2","title":"Dilute.Resolution.derive_resolution/2","type":"function","doc":"Derives the Dilute.Resolution for the given Absinthe.Resolution"},{"ref":"Dilute.Resolution.html#joins/1","title":"Dilute.Resolution.joins/1","type":"function","doc":""},{"ref":"Dilute.Resolver.html","title":"Dilute.Resolver","type":"module","doc":"The Resolver implements the resolve/3 function for the given types and their repo. The resolver requires the parent element to be %{} and build the query and submits the request based on the Resolution derived from the Absinthe.Resolution, args are not evaluated since they are included in the Absinthe resolution."},{"ref":"Dilute.SchemaError.html","title":"Dilute.SchemaError","type":"exception","doc":"Raised during compiletime for unrecveralbe errors in the schema"},{"ref":"DiluteTest.DataCase.html","title":"DiluteTest.DataCase","type":"module","doc":""},{"ref":"DiluteTest.Environment.Absinthe.Resolver.html","title":"DiluteTest.Environment.Absinthe.Resolver","type":"module","doc":""},{"ref":"DiluteTest.Environment.Absinthe.Resolver.html#resolve/3","title":"DiluteTest.Environment.Absinthe.Resolver.resolve/3","type":"function","doc":""},{"ref":"DiluteTest.Environment.Absinthe.Schema.html","title":"DiluteTest.Environment.Absinthe.Schema","type":"module","doc":""},{"ref":"DiluteTest.Environment.Absinthe.Types.html","title":"DiluteTest.Environment.Absinthe.Types","type":"module","doc":""},{"ref":"DiluteTest.Environment.Absinthe.Types.SomeModuleNotCompilableModule.html","title":"DiluteTest.Environment.Absinthe.Types.SomeModuleNotCompilableModule","type":"module","doc":""},{"ref":"DiluteTest.Environment.Absinthe.Types.SomeModuleNotCompilableModule.html#hello/0","title":"DiluteTest.Environment.Absinthe.Types.SomeModuleNotCompilableModule.hello/0","type":"function","doc":""},{"ref":"DiluteTest.Environment.Ecto.Comment.html","title":"DiluteTest.Environment.Ecto.Comment","type":"module","doc":""},{"ref":"DiluteTest.Environment.Ecto.CreateComment.html","title":"DiluteTest.Environment.Ecto.CreateComment","type":"module","doc":""},{"ref":"DiluteTest.Environment.Ecto.Message.html","title":"DiluteTest.Environment.Ecto.Message","type":"module","doc":""},{"ref":"DiluteTest.Environment.Ecto.Post.html","title":"DiluteTest.Environment.Ecto.Post","type":"module","doc":""},{"ref":"DiluteTest.Environment.Ecto.Repo.html","title":"DiluteTest.Environment.Ecto.Repo","type":"module","doc":""},{"ref":"DiluteTest.Environment.Ecto.Repo.html#aggregate/4","title":"DiluteTest.Environment.Ecto.Repo.aggregate/4","type":"function","doc":"Calculate the given aggregate over the given field. If the query has a limit, offset or distinct set, it will be automatically wrapped in a subquery in order to return the proper result. Any preload or select in the query will be ignored in favor of the column being aggregated. The aggregation will fail if any group_by field is set. Options See the &quot;Shared options&quot; section at the module documentation. Examples # Returns the number of visits per blog post Repo.aggregate(Post, :count, :visits) # Returns the average number of visits for the top 10 query = from Post, limit: 10 Repo.aggregate(query, :avg, :visits) Callback implementation for Ecto.Repo.aggregate/4."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#all/2","title":"DiluteTest.Environment.Ecto.Repo.all/2","type":"function","doc":"Fetches all entries from the data store matching the given query. May raise Ecto.QueryError if query validation fails. Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This overrides the prefix set in the query. See the &quot;Shared options&quot; section at the module documentation. Example # Fetch all post titles query = from p in Post, select: p.title MyRepo.all(query) Callback implementation for Ecto.Repo.all/2."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#child_spec/1","title":"DiluteTest.Environment.Ecto.Repo.child_spec/1","type":"function","doc":""},{"ref":"DiluteTest.Environment.Ecto.Repo.html#config/0","title":"DiluteTest.Environment.Ecto.Repo.config/0","type":"function","doc":"Returns the adapter configuration stored in the :otp_app environment. If the c:init/2 callback is implemented in the repository, it will be invoked with the first argument set to :dry_run. Callback implementation for Ecto.Repo.config/0."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#delete/2","title":"DiluteTest.Environment.Ecto.Repo.delete/2","type":"function","doc":"Deletes a struct using its primary key. If the struct has no primary key, Ecto.NoPrimaryKeyFieldError will be raised. It returns {:ok, struct} if the struct has been successfully deleted or {:error, changeset} if there was a validation or a known constraint error. Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This overrides the prefix set in the struct. See the &quot;Shared options&quot; section at the module documentation. Example post = MyRepo.get!(Post, 42) case MyRepo.delete post do {:ok, struct} -&gt; # Deleted with success {:error, changeset} -&gt; # Something went wrong end Callback implementation for Ecto.Repo.delete/2."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#delete!/2","title":"DiluteTest.Environment.Ecto.Repo.delete!/2","type":"function","doc":"Same as c:delete/2 but returns the struct or raises if the changeset is invalid. Callback implementation for Ecto.Repo.delete!/2."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#delete_all/2","title":"DiluteTest.Environment.Ecto.Repo.delete_all/2","type":"function","doc":"Deletes all entries matching the given query. It returns a tuple containing the number of entries and any returned result as second element. If the database does not support RETURNING in DELETE statements or no return result was selected, the second element will be nil. Options :returning - selects which fields to return. When true, returns all fields in the given struct. May be a list of fields, where a struct is still returned but only with the given fields. Or false, where nothing is returned (the default). This option is not supported by all databases. :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This overrides the prefix set in the query. See the &quot;Shared options&quot; section at the module documentation for remaining options. Examples MyRepo.delete_all(Post) from(p in Post, where: p.id &lt; 10) |&gt; MyRepo.delete_all Callback implementation for Ecto.Repo.delete_all/2."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#get/3","title":"DiluteTest.Environment.Ecto.Repo.get/3","type":"function","doc":"Fetches a single struct from the data store where the primary key matches the given id. Returns nil if no result was found. If the struct in the queryable has no or more than one primary key, it will raise an argument error. Options See the &quot;Shared options&quot; section at the module documentation. Example MyRepo.get(Post, 42) Callback implementation for Ecto.Repo.get/3."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#get!/3","title":"DiluteTest.Environment.Ecto.Repo.get!/3","type":"function","doc":"Similar to c:get/3 but raises Ecto.NoResultsError if no record was found. Options See the &quot;Shared options&quot; section at the module documentation. Example MyRepo.get!(Post, 42) Callback implementation for Ecto.Repo.get!/3."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#get_by/3","title":"DiluteTest.Environment.Ecto.Repo.get_by/3","type":"function","doc":"Fetches a single result from the query. Returns nil if no result was found. Options See the &quot;Shared options&quot; section at the module documentation. Example MyRepo.get_by(Post, title: &quot;My post&quot;) Callback implementation for Ecto.Repo.get_by/3."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#get_by!/3","title":"DiluteTest.Environment.Ecto.Repo.get_by!/3","type":"function","doc":"Similar to get_by/3 but raises Ecto.NoResultsError if no record was found. Options See the &quot;Shared options&quot; section at the module documentation. Example MyRepo.get_by!(Post, title: &quot;My post&quot;) Callback implementation for Ecto.Repo.get_by!/3."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#in_transaction?/0","title":"DiluteTest.Environment.Ecto.Repo.in_transaction?/0","type":"function","doc":"Returns true if the current process is inside a transaction. Examples MyRepo.in_transaction? #=&gt; false MyRepo.transaction(fn -&gt; MyRepo.in_transaction? #=&gt; true end) Callback implementation for Ecto.Repo.in_transaction?/0."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#insert/2","title":"DiluteTest.Environment.Ecto.Repo.insert/2","type":"function","doc":"Inserts a struct defined via Ecto.Schema or a changeset. In case a struct is given, the struct is converted into a changeset with all non-nil fields as part of the changeset. In case a changeset is given, the changes in the changeset are merged with the struct fields, and all of them are sent to the database. It returns {:ok, struct} if the struct has been successfully inserted or {:error, changeset} if there was a validation or a known constraint error. Options :returning - selects which fields to return. When true, returns all fields in the given struct. May be a list of fields, where a struct is still returned but only with the given fields. In any case, it will include fields with read_after_writes set to true. This option is not supported by all databases. :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This overrides the prefix set in the struct. :on_conflict - It may be one of :raise (the default), :nothing, :replace_all, a keyword list of update instructions or an Ecto.Query query for updates. See the &quot;Upserts&quot; section for more information. :conflict_target - Which columns to verify for conflicts. If none is specified, the conflict target is left up to the database and is usually made of primary keys and/or unique/exclusion constraints. May also be {:constraint, constraint_name_as_atom} in databases that support the &quot;ON CONSTRAINT&quot; expression. See the &quot;Shared options&quot; section at the module documentation. Examples A typical example is calling MyRepo.insert/1 with a struct and acting on the return value: case MyRepo.insert %Post{title: &quot;Ecto is great&quot;} do {:ok, struct} -&gt; # Inserted with success {:error, changeset} -&gt; # Something went wrong end Upserts c:insert/2 provides upserts (update or inserts) via the :on_conflict option. The :on_conflict option supports the following values: :raise - raises if there is a conflicting primary key or unique index :nothing - ignores the error in case of conflicts :replace_all - replace all values on the existing row with the values in the excluded row (the record given in the function parameters) a keyword list of update instructions - such as the one given to c:update_all/3, for example: [set: [title: &quot;new title&quot;]] an Ecto.Query that will act as an UPDATE statement, such as the one given to c:update_all/3 Upserts map to &quot;ON CONFLICT&quot; on databases like Postgres and &quot;ON DUPLICATE KEY&quot; on databases such as MySQL. As an example, imagine :title is marked as a unique column in the database: {:ok, inserted} = MyRepo.insert(%Post{title: &quot;this is unique&quot;}) Now we can insert with the same title but do nothing on conflicts: {:ok, ignored} = MyRepo.insert(%Post{title: &quot;this is unique&quot;}, on_conflict: :nothing) assert ignored.id == nil Because we used on_conflict: :nothing, instead of getting an error, we got {:ok, struct}. However the returned struct does not reflect the data in the database. One possible mechanism to detect if an insert or nothing happened in case of on_conflict: :nothing is by checking the id field. id will be nil if the field is autogenerated by the database and no insert happened. For actual upserts, where an insert or update may happen, the situation is slightly more complex, as the database does not actually inform us if an insert or update happened. Let&#39;s insert a post with the same title but use a query to update the body column in case of conflicts: # In Postgres (it requires the conflict target for updates): on_conflict = [set: [body: &quot;updated&quot;]] {:ok, updated} = MyRepo.insert(%Post{title: &quot;this is unique&quot;}, on_conflict: on_conflict, conflict_target: :title) # In MySQL (conflict target is not supported): on_conflict = [set: [title: &quot;updated&quot;]] {:ok, updated} = MyRepo.insert(%Post{id: inserted.id, title: &quot;updated&quot;}, on_conflict: on_conflict) In the examples above, even though it returned :ok, we do not know if we inserted new data or if we updated only the :on_conflict fields. In case an update happened, the data in the struct most likely does not match the data in the database. For example, autogenerated fields such as inserted_at will point to now rather than the time the struct was actually inserted. If you need to guarantee the data in the returned struct mirrors the database, you have three options: Use on_conflict: :replace_all, although that will replace all fields in the database with current ones: MyRepo.insert(%Post{title: &quot;this is unique&quot;}, on_conflict: :replace_all, conflict_target: :title) Specify read_after_writes: true in your schema for choosing fields that are read from the database after every operation. Or pass returning: true to insert to read all fields back: MyRepo.insert(%Post{title: &quot;this is unique&quot;}, returning: true, on_conflict: on_conflict, conflict_target: :title) Alternatively, read the data again from the database in a separate query. This option requires the primary key to be generated by the database: {:ok, updated} = MyRepo.insert(%Post{title: &quot;this is unique&quot;}, on_conflict: on_conflict) Repo.get(Post, updated.id) Because of the inability to know if the struct is up to date or not, using associations with the :on_conflict option is not recommended. For instance, Ecto may even trigger constraint violations when associations are used with on_conflict: :nothing, as no ID will be available in the case the record already exists, and it is not possible for Ecto to detect such cases reliably. Callback implementation for Ecto.Repo.insert/2."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#insert!/2","title":"DiluteTest.Environment.Ecto.Repo.insert!/2","type":"function","doc":"Same as c:insert/2 but returns the struct or raises if the changeset is invalid. Callback implementation for Ecto.Repo.insert!/2."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#insert_all/3","title":"DiluteTest.Environment.Ecto.Repo.insert_all/3","type":"function","doc":"Inserts all entries into the repository. It expects a schema (MyApp.User) or a source (&quot;users&quot;) or both ({&quot;users&quot;, MyApp.User}) as the first argument. The second argument is a list of entries to be inserted, either as keyword lists or as maps. It returns a tuple containing the number of entries and any returned result as second element. If the database does not support RETURNING in INSERT statements or no return result was selected, the second element will be nil. When a schema is given, the values given will be properly dumped before being sent to the database. If the schema contains an autogenerated ID field, it will be handled either at the adapter or the storage layer. However any other autogenerated value, like timestamps, won&#39;t be autogenerated when using c:insert_all/3. This is by design as this function aims to be a more direct way to insert data into the database without the conveniences of c:insert/2. This is also consistent with c:update_all/3 that does not handle timestamps as well. It is also not possible to use insert_all to insert across multiple tables, therefore associations are not supported. If a source is given, without a schema, the given fields are passed as is to the adapter. Options :returning - selects which fields to return. When true, returns all fields in the given struct. May be a list of fields, where a struct is still returned but only with the given fields. Or false, where nothing is returned (the default). This option is not supported by all databases. :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). :on_conflict - It may be one of :raise (the default), :nothing, :replace_all, a keyword list of update instructions or an Ecto.Query query for updates. See the &quot;Upserts&quot; section for more information. :conflict_target - Which columns to verify for conflicts. If none is specified, the conflict target is left up to the database and is usually made of primary keys and/or unique/exclusion constraints. May also be {:constraint, constraint_name_as_atom} in databases that support the &quot;ON CONSTRAINT&quot; expression. See the &quot;Shared options&quot; section at the module documentation for remaining options. Examples MyRepo.insert_all(Post, [[title: &quot;My first post&quot;], [title: &quot;My second post&quot;]]) MyRepo.insert_all(Post, [%{title: &quot;My first post&quot;}, %{title: &quot;My second post&quot;}]) Upserts c:insert_all/3 provides upserts (update or inserts) via the :on_conflict option. The :on_conflict option supports the following values: :raise - raises if there is a conflicting primary key or unique index :nothing - ignores the error in case of conflicts :replace_all - replace all values on the existing row with the values in the excluded row (the corresponding record given in the function parameters) a keyword list of update instructions - such as the one given to c:update_all/3, for example: [set: [title: &quot;new title&quot;]] an Ecto.Query that will act as an UPDATE statement, such as the one given to c:update_all/3 Upserts map to &quot;ON CONFLICT&quot; on databases like Postgres and &quot;ON DUPLICATE KEY&quot; on databases such as MySQL. Return values By default, both Postgres and MySQL return the amount of entries inserted on c:insert_all/3. However, when the :on_conflict option is specified, Postgres will only return a row if it was affected while MySQL returns at least the number of entries attempted. For example, if :on_conflict is set to :nothing, Postgres will return 0 if no new entry was added while MySQL will still return the amount of entries attempted to be inserted, even if no entry was added. Even worse, if :on_conflict is query, MySQL will return the number of attempted entries plus the number of entries modified by the UPDATE query. Callback implementation for Ecto.Repo.insert_all/3."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#insert_or_update/2","title":"DiluteTest.Environment.Ecto.Repo.insert_or_update/2","type":"function","doc":"Inserts or updates a changeset depending on whether the struct is persisted or not. The distinction whether to insert or update will be made on the Ecto.Schema.Metadata field :state. The :state is automatically set by Ecto when loading or building a schema. Please note that for this to work, you will have to load existing structs from the database. So even if the struct exists, this won&#39;t work: struct = %Post{id: &quot;existing_id&quot;, ...} MyRepo.insert_or_update changeset # =&gt; {:error, changeset} # id already exists Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This overrides the prefix set in the struct. See the &quot;Shared options&quot; section at the module documentation. Example result = case MyRepo.get(Post, id) do nil -&gt; %Post{id: id} # Post not found, we build one post -&gt; post # Post exists, let&#39;s use it end |&gt; Post.changeset(changes) |&gt; MyRepo.insert_or_update case result do {:ok, struct} -&gt; # Inserted or updated with success {:error, changeset} -&gt; # Something went wrong end Callback implementation for Ecto.Repo.insert_or_update/2."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#insert_or_update!/2","title":"DiluteTest.Environment.Ecto.Repo.insert_or_update!/2","type":"function","doc":"Same as c:insert_or_update/2 but returns the struct or raises if the changeset is invalid. Callback implementation for Ecto.Repo.insert_or_update!/2."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#load/2","title":"DiluteTest.Environment.Ecto.Repo.load/2","type":"function","doc":"Loads data into a struct or a map. The first argument can be a schema, or a map (of types) and determines the return value: a struct or a map, respectively. The second argument data specifies fields and values that are to be loaded. It can be a map, a keyword list, or a {fields, values} tuple. Fields can be atoms or strings. Fields that are not present in the schema (or types map) are ignored. If any of the values has invalid type, an error is raised. Examples iex&gt; MyRepo.load(User, %{name: &quot;Alice&quot;, age: 25}) %User{name: &quot;Alice&quot;, age: 25} iex&gt; MyRepo.load(User, [name: &quot;Alice&quot;, age: 25]) %User{name: &quot;Alice&quot;, age: 25} data can also take form of {fields, values}: iex&gt; MyRepo.load(User, {[:name, :age], [&quot;Alice&quot;, 25]}) %User{name: &quot;Alice&quot;, age: 25, ...} The first argument can also be a types map: iex&gt; types = %{name: :string, age: :integer} iex&gt; MyRepo.load(types, %{name: &quot;Alice&quot;, age: 25}) %{name: &quot;Alice&quot;, age: 25} This function is especially useful when parsing raw query results: iex&gt; result = Ecto.Adapters.SQL.query!(MyRepo, &quot;SELECT * FROM users&quot;, []) iex&gt; Enum.map(result.rows, &amp;MyRepo.load(User, {result.columns, &amp;1})) [%User{...}, ...] Callback implementation for Ecto.Repo.load/2."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#one/2","title":"DiluteTest.Environment.Ecto.Repo.one/2","type":"function","doc":"Fetches a single result from the query. Returns nil if no result was found. Raises if more than one entry. Options See the &quot;Shared options&quot; section at the module documentation. Callback implementation for Ecto.Repo.one/2."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#one!/2","title":"DiluteTest.Environment.Ecto.Repo.one!/2","type":"function","doc":"Similar to c:one/2 but raises Ecto.NoResultsError if no record was found. Raises if more than one entry. Options See the &quot;Shared options&quot; section at the module documentation. Callback implementation for Ecto.Repo.one!/2."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#preload/3","title":"DiluteTest.Environment.Ecto.Repo.preload/3","type":"function","doc":"Preloads all associations on the given struct or structs. This is similar to Ecto.Query.preload/3 except it allows you to preload structs after they have been fetched from the database. In case the association was already loaded, preload won&#39;t attempt to reload it. Options Besides the &quot;Shared options&quot; section at the module documentation, it accepts: :force - By default, Ecto won&#39;t preload associations that are already loaded. By setting this option to true, any existing association will be discarded and reloaded. :in_parallel - If the preloads must be done in parallel. It can only be performed when we have more than one preload and the repository is not in a transaction. Defaults to true. :prefix - the prefix to fetch preloads from. By default, queries will use the same prefix as the one in the given collection. This option allows the prefix to be changed. Examples # Use a single atom to preload an association posts = Repo.preload posts, :comments # Use a list of atoms to preload multiple associations posts = Repo.preload posts, [:comments, :authors] # Use a keyword list to preload nested associations as well posts = Repo.preload posts, [comments: [:replies, :likes], authors: []] # Use a keyword list to customize how associations are queried posts = Repo.preload posts, [comments: from(c in Comment, order_by: c.published_at)] # Use a two-element tuple for a custom query and nested association definition query = from c in Comment, order_by: c.published_at posts = Repo.preload posts, [comments: {query, [:replies, :likes]}] Note: The query given to preload may also preload its own associations. Callback implementation for Ecto.Repo.preload/3."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#query/3","title":"DiluteTest.Environment.Ecto.Repo.query/3","type":"function","doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query/3 for more information."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#query!/3","title":"DiluteTest.Environment.Ecto.Repo.query!/3","type":"function","doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query/3 for more information."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#rollback/1","title":"DiluteTest.Environment.Ecto.Repo.rollback/1","type":"function","doc":"Rolls back the current transaction. The transaction will return the value given as {:error, value}. Callback implementation for Ecto.Repo.rollback/1."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#start_link/1","title":"DiluteTest.Environment.Ecto.Repo.start_link/1","type":"function","doc":"Starts any connection pooling or supervision and return {:ok, pid} or just :ok if nothing needs to be done. Returns {:error, {:already_started, pid}} if the repo is already started or {:error, term} in case anything else goes wrong. Options See the configuration in the moduledoc for options shared between adapters, for adapter-specific configuration see the adapter&#39;s documentation. Callback implementation for Ecto.Repo.start_link/1."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#stop/2","title":"DiluteTest.Environment.Ecto.Repo.stop/2","type":"function","doc":"Shuts down the repository represented by the given pid. Callback implementation for Ecto.Repo.stop/2."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#stream/2","title":"DiluteTest.Environment.Ecto.Repo.stream/2","type":"function","doc":"Returns a lazy enumerable that emits all entries from the data store matching the given query. SQL adapters, such as Postgres and MySQL, can only enumerate a stream inside a transaction. May raise Ecto.QueryError if query validation fails. Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This overrides the prefix set in the query :max_rows - The number of rows to load from the database as we stream. It is supported at least by Postgres and MySQL and defaults to 500. See the &quot;Shared options&quot; section at the module documentation. Example # Fetch all post titles query = from p in Post, select: p.title stream = MyRepo.stream(query) MyRepo.transaction(fn() -&gt; Enum.to_list(stream) end) Callback implementation for Ecto.Repo.stream/2."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#to_sql/2","title":"DiluteTest.Environment.Ecto.Repo.to_sql/2","type":"function","doc":"A convenience function for SQL-based repositories that translates the given query to SQL. See Ecto.Adapters.SQL.query/3 for more information."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#transaction/2","title":"DiluteTest.Environment.Ecto.Repo.transaction/2","type":"function","doc":"Runs the given function or Ecto.Multi inside a transaction. Use with function If an unhandled error occurs the transaction will be rolled back and the error will bubble up from the transaction function. If no error occurred the transaction will be committed when the function returns. A transaction can be explicitly rolled back by calling c:rollback/1, this will immediately leave the function and return the value given to rollback as {:error, value}. A successful transaction returns the value returned by the function wrapped in a tuple as {:ok, value}. If c:transaction/2 is called inside another transaction, the function is simply executed, without wrapping the new transaction call in any way. If there is an error in the inner transaction and the error is rescued, or the inner transaction is rolled back, the whole outer transaction is marked as tainted, guaranteeing nothing will be committed. Use with Ecto.Multi Besides functions transaction can be used with an Ecto.Multi struct. Transaction will be started, all operations applied and in case of success committed returning {:ok, changes}. In case of any errors the transaction will be rolled back and {:error, failed_operation, failed_value, changes_so_far} will be returned. You can read more about using transactions with Ecto.Multi as well as see some examples in the Ecto.Multi documentation. Options See the &quot;Shared options&quot; section at the module documentation. Examples import Ecto.Changeset, only: [change: 2] MyRepo.transaction(fn -&gt; MyRepo.update!(change(alice, balance: alice.balance - 10)) MyRepo.update!(change(bob, balance: bob.balance + 10)) end) # Roll back a transaction explicitly MyRepo.transaction(fn -&gt; p = MyRepo.insert!(%Post{}) if not Editor.post_allowed?(p) do MyRepo.rollback(:posting_not_allowed) end end) # With Ecto.Multi Ecto.Multi.new |&gt; Ecto.Multi.insert(:post, %Post{}) |&gt; MyRepo.transaction Callback implementation for Ecto.Repo.transaction/2."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#update/2","title":"DiluteTest.Environment.Ecto.Repo.update/2","type":"function","doc":"Updates a changeset using its primary key. A changeset is required as it is the only mechanism for tracking dirty changes. Only the fields present in the changes part of the changeset are sent to the database. Any other, in-memory changes done to the schema are ignored. If the struct has no primary key, Ecto.NoPrimaryKeyFieldError will be raised. It returns {:ok, struct} if the struct has been successfully updated or {:error, changeset} if there was a validation or a known constraint error. Options Besides the &quot;Shared options&quot; section at the module documentation, it accepts: :force - By default, if there are no changes in the changeset, c:update/2 is a no-op. By setting this option to true, update callbacks will always be executed, even if there are no changes (including timestamps). :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This overrides the prefix set in the struct. Example post = MyRepo.get!(Post, 42) post = Ecto.Changeset.change post, title: &quot;New title&quot; case MyRepo.update post do {:ok, struct} -&gt; # Updated with success {:error, changeset} -&gt; # Something went wrong end Callback implementation for Ecto.Repo.update/2."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#update!/2","title":"DiluteTest.Environment.Ecto.Repo.update!/2","type":"function","doc":"Same as c:update/2 but returns the struct or raises if the changeset is invalid. Callback implementation for Ecto.Repo.update!/2."},{"ref":"DiluteTest.Environment.Ecto.Repo.html#update_all/3","title":"DiluteTest.Environment.Ecto.Repo.update_all/3","type":"function","doc":"Updates all entries matching the given query with the given values. It returns a tuple containing the number of entries and any returned result as second element. If the database does not support RETURNING in UPDATE statements or no return result was selected, the second element will be nil. Keep in mind this update_all will not update autogenerated fields like the updated_at columns. See Ecto.Query.update/3 for update operations that can be performed on fields. Options :returning - selects which fields to return. When true, returns all fields in the given struct. May be a list of fields, where a struct is still returned but only with the given fields. Or false, where nothing is returned (the default). This option is not supported by all databases. :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This overrides the prefix set in the query. See the &quot;Shared options&quot; section at the module documentation for remaining options. Examples MyRepo.update_all(Post, set: [title: &quot;New title&quot;]) MyRepo.update_all(Post, inc: [visits: 1]) from(p in Post, where: p.id &lt; 10) |&gt; MyRepo.update_all(set: [title: &quot;New title&quot;]) from(p in Post, where: p.id &lt; 10, update: [set: [title: &quot;New title&quot;]]) |&gt; MyRepo.update_all([]) from(p in Post, where: p.id &lt; 10, update: [set: [title: ^new_title]]) |&gt; MyRepo.update_all([]) from(p in Post, where: p.id &lt; 10, update: [set: [title: fragment(&quot;upper(?)&quot;, ^new_title)]]) |&gt; MyRepo.update_all([]) Callback implementation for Ecto.Repo.update_all/3."},{"ref":"DiluteTest.Environment.Ecto.TestSchema.html","title":"DiluteTest.Environment.Ecto.TestSchema","type":"module","doc":""},{"ref":"DiluteTest.Environment.Ecto.UnixTime.html","title":"DiluteTest.Environment.Ecto.UnixTime","type":"module","doc":""},{"ref":"DiluteTest.Environment.Ecto.UnixTime.html#cast/1","title":"DiluteTest.Environment.Ecto.UnixTime.cast/1","type":"function","doc":"Casts the given input to the custom type. This callback is called on external input and can return any type, as long as the dump/1 function is able to convert the returned value into an Ecto native type. There are two situations where this callback is called: When casting values by Ecto.Changeset When passing arguments to Ecto.Query Callback implementation for Ecto.Type.cast/1."},{"ref":"DiluteTest.Environment.Ecto.UnixTime.html#dump/1","title":"DiluteTest.Environment.Ecto.UnixTime.dump/1","type":"function","doc":"Dumps the given term into an Ecto native type. This callback is called with any term that was stored in the struct and it needs to validate them and convert it to an Ecto native type. Callback implementation for Ecto.Type.dump/1."},{"ref":"DiluteTest.Environment.Ecto.UnixTime.html#load/1","title":"DiluteTest.Environment.Ecto.UnixTime.load/1","type":"function","doc":"Loads the given term into a custom type. This callback is called when loading data from the database and receive an Ecto native type. It can return any type, as long as the dump/1 function is able to convert the returned value back into an Ecto native type. Callback implementation for Ecto.Type.load/1."},{"ref":"DiluteTest.Environment.Ecto.UnixTime.html#type/0","title":"DiluteTest.Environment.Ecto.UnixTime.type/0","type":"function","doc":"Returns the underlying schema type for the custom type. For example, if you want to provide your own date structures, the type function should return :date. Note this function is not required to return Ecto primitive types, the type is only required to be known by the adapter. Callback implementation for Ecto.Type.type/0."},{"ref":"DiluteTest.Environment.NoEctoSchema.html","title":"DiluteTest.Environment.NoEctoSchema","type":"module","doc":""},{"ref":"DiluteTest.Environment.NoEctoSchema.html#hello/0","title":"DiluteTest.Environment.NoEctoSchema.hello/0","type":"function","doc":""}]